// Copyright 2010
// Author: Li Zhang
#include <stdlib.h>
#include <iostream>
#include <string>
#include <cctype>
#include <algorithm>
#include <utility>
#include <vector>
#include "./NussinovAlgorithm.h"

using std::cout;
using std::endl;
using std::cin;
using std::string;
using std::flush;

#define MAX_SEQUENCE 2000

void input(const string& input)
{
  cout << "Input sequence => " << input << endl;
  NussinovAlgorithm tmpRNAFolding;
  std::vector<std::pair<int, int> > result;
  tmpRNAFolding.computeStructure(input, &result);
  cout << endl;
  cout <<"The structure is as follows:" << endl;
  tmpRNAFolding.printStructure(result);
  cout << endl;
  cout << "The matrix is as follows:" << endl;
  tmpRNAFolding.printMatrix();
}

int main(int argc, char** argv)
{
  if (argc != 2)
  {
    printf("Usage:please input a string consisting of 'a', 'u', 'c', 'g'.\n"
        "For example: ./NussinovAlgorithmMain aucg.");
    exit(1);
  }
  input(argv[1]);
  return 0;
}
